<template>
  <pre class="border rounded mt-4 bg-grey-lightest overflow-auto">
      <code>
        <p
          class="pl-8"
          v-html="prettyJSON"
        />
      </code>
    </pre>
</template>

<script lang="ts">
import { Vue, Component, Prop } from 'vue-property-decorator'

function jsonReplace (match, pIndent, pKey, pVal, pEnd) {
  const key = '<span class="text-red">'
  const val = '<span class="text-blue">'
  const str = '<span class="text-green">'
  let r = pIndent || ''
  if (pKey) {
    r = r + key + pKey.replace(/[": ]/g, '') + '</span>: '
  }
  if (pVal) {
    r = r + (pVal[0] === '"' ? str : val) + pVal + '</span>'
  }
  return r + (pEnd || '')
}

function prettyPrint (obj) {
  const jsonLine = /^( *)("[\w]+": )?("[^"]*"|[\w.+-]*)?([,[{])?$/mg

  return JSON.stringify(obj, null, 3)
    .replace(/&/g, '&amp;').replace(/\\"/g, '&quot;')
    .replace(/</g, '&lt;').replace(/>/g, '&gt;')
    .replace(jsonLine, jsonReplace)
}

@Component
export default class SettingsJSON extends Vue {
  @Prop(Object) json

  get prettyJSON () {
    return prettyPrint(this.json)
  }
}

</script>
